#! /usr/bin/python

import os
import datetime
import sys
import time
import hashlib

from string import maketrans

import MySQLdb
import header

header.setIncludePath()
import dbconnect

dbconn=dbconnect.dbconn()
db=MySQLdb.connect(host=dbconn[0],user=dbconn[1],passwd=dbconn[2], db=dbconn[3])
cursor=db.cursor()


dbconn2=dbconnect.srconn()
db2=MySQLdb.connect(host=dbconn2[0],user=dbconn2[1],passwd=dbconn2[2], db=dbconn2[3])
db2.autocommit(1)
cursor2=db2.cursor()


def getCWD () :
	
	cwd = os.getcwd() 
	
	return ( cwd + "/" )

def checkCRXDir() :
	
	cwd = getCWD()
	correxDir = cwd + 'zcorrex/'
	fitsDir = cwd
	
	#correxDir = '/stars2/html/zcorrex/'
	#fitsDir = '/stars2/html/'
	
	listfilesC = os.listdir ( correxDir )
	listfilesF = os.listdir ( fitsDir )
	
#	listfilesC2=listfilesC.sort()
	
#	listfilesF=listfilesF.sort()

	dirfiles=[]
		
	for item in listfilesC :
	
		if item is not None:
		
			dirfiles.append( item )
	
	dirfiles.sort()	
	
	for lineC in dirfiles :

#	correctionsArray = ()
		
#	for lineC in listfilesC2 :
		
		ext = lineC [-4:]
		
		frameID_C = lineC [0:12]
		
#		print ('Frame ID: ' + frameID_C )
		
		if ext == '.crx' :
		
			print ('Corrections File: ' + lineC)
			
#			correctionsArray.append( frameID_C )

#			for lineF in listfilesF :
#				print 'A-' +lineC 
#				ext = lineC[ -5: ]
#				frameID_F = lineF [0:12]
#				print 'A-'  + frameID_F 
				
#				if frameID_F == frameID_C:
#				
#					print ('Found match: ' + frameID_F + " " +  frameID_C )
#					
#					readOldFits( frameID_F, 'REQ-FWHM' )
					
					
				
#		else :
#			print ('Error: ' + ext)

#	correctionsArray.sort()	
	
#	print ("crx2" + str( correctionsArray ) )
	
	return( dirfiles )

def displayCorrex () :	

	cwd = getCWD()
	correxDir = cwd + 'zcorrex/'
	
	listfilesC = os.listdir ( correxDir )
	
#	listfilesC2 = listfilesC.sort()

	dirfiles=[]
		
	for item in listfilesC :
	
		if item is not None:
		
			dirfiles.append( item )
	
	dirfiles.sort()	
	
	for lineC in dirfiles :

#	for lineC in listfilesC :
		
		ext = lineC [-4:]
		
		frameID_C = lineC [0:12]
				
		if ext == '.crx' :
		
			print ('** Corrections File: ' + lineC)
						
			allCorrections = getCorrex ( frameID_C )
			
			print ( allCorrections )

def getCorrex( filename ) :

#	cwd = getCWD()

#	correxDir = cwd + 'zcorrex/'

#	filename = correxDir + 'HSCA90939557.crx'
#	filename = correxDir + filename + '.crx'

#	filename = '/stars2/html/zcorrex/' + filename + '.crx'

	# 'w' - erase file before opening
	# 'a' append to file
	# 'r' read from file

	AllCorrectLines = ''
	

	
	if os.path.exists ( filename ) :

#		print( "File Exists: " + filename )

		FILE1 = open ( filename, 'rb' )
		listfiles = FILE1.readlines()
		FILE1.close()

#		print ( "getCorrecx.listfiles: " + str( listfiles )) 

		lineseq = 0

		for line in listfiles :

			lineseq += 1
			line = line.strip()

#			print( str( lineseq ) + " " + line)

			if lineseq == 2:

	# this is the linenumber in the oldfitsfile for Keyword

				fitsline = line[2:5]
#				print("fitsline: "+str( fitsline ) )

	# ignore comments

#			if line[0] == "#":

#				print ("This is a comment: " + line)
	# collect correctline
			if not line[0] == "#":

#			else:
#				# print keyword 

				CorrectLine = line
				
				AllCorrectLines += CorrectLine + "\n"
				
#				CorrectLine = CorrectLine.ljust( 80, " " )

				keyword = line[0:8] 
#				print (str (lineseq) + " keyword: [ " + keyword + " ] is not a comment: " + line)

				# print value

				value = line[9:15] 
#				print (str (lineseq) + " value: [ " + value + " ] is not a comment: " + line)



	else: 
		print( "File Not Exists: " + filename )

#	return ( CorrectLine, CorrecLines )
	return ( AllCorrectLines )

	
# read FITS file

def writeCorrex( filename, AllCorrectLines ) :

#	write = 'yes'
	write = 'no'	
	#
#	oldfitsFile =  '/stars2/html/HSCA90939557.fits'
#	newfitsFile =  '/stars2/html/HSCA90939557-A.fits'


#	cwd = getCWD()
	
#	fitsDir = '/stars2/html/test/fits'

	oldfitsFile = filename
#	oldfitsFile = fitsDir + filename + '.fits'

#	newfitsFile = fitsDir + filename + '-A.fits'
#	newfitsFile = '/stars2/html/HSCA00020541-A.fits'
	
#	keyword = CorrectLine[0:8]

	kwCorrections = []

	AllCorrections = AllCorrectLines.split("\n")

	for CorrectLine in AllCorrections :
	
		if len( CorrectLine ) > 0:
		
			kwCorrect = CorrectLine[0:8]
			if kwCorrect not in kwCorrections :
				kwCorrections.append( kwCorrect )
	

	print("Corrections: " + str(kwCorrections))
	# test for file exists

	fits_bytes = 0
	grab_bytes = 80 
	
	m = hashlib.md5()
	
	if os.path.exists ( oldfitsFile ) :

	# read file
	# why readlines?

		print ("File exists: " + oldfitsFile)
		FILE2 = open ( oldfitsFile, 'rb' )
	#	listfiles = FILE2.readlines()

		if write == 'yes' :
	
			FILE3 = open ( newfitsFile, 'wb')
			
#		linemax = int( fitsline )
		linemax = 190
		lineseq = 0

		badkeys = ( 'COMMENT', 'HISTORY' )

#		while lineseq < linemax:

		while True :
		
			lineseq += 1

			listfiles2 = FILE2.read( grab_bytes )

#			if listfiles2 is None:
#			if len( listfiles2 ) == 0:

			if not listfiles2:
			
				break

			fits_bytes += grab_bytes

			lineLength = len( listfiles2 )

#			print( listfiles2 )

#			print("This " + str( lineseq )  + " line is : "+str( lineLength ) )

			kw = listfiles2[0:8]
			
			if not kw in kwCorrections:

#				print ('Copying ' + listfiles2 )
# Update md5 
				m.update ( listfiles2 )
		#
				if write == 'yes' :

					FILE3.write( listfiles2 )
					
			else: 
						
				AllCorrections = AllCorrectLines.split("\n")

				for FixLine in AllCorrections :
				
					if len ( FixLine ) > 0 :

						kwCorrect = FixLine[0:8]

						if kwCorrect == kw :

							CorrectLine = FixLine.strip()				
							lengthcorrectLine = len( CorrectLine )

							print("lengthCorrectLine: "+ str( lengthcorrectLine ))

							crxFragments = CorrectLine.split("=")

							keyword1 = crxFragments[0]
							values1 = crxFragments[1]

							values1 = values1.strip()

							lineFragments = listfiles2.split("=")

							keyword2 = lineFragments[0]
							values2 = lineFragments[1]
							oldvalue = values2.strip()
							strpos = oldvalue.find(' / ')


							values2 = values2.strip()

							comment = ''	

							if strpos > 0 :

								comment = oldvalue[ strpos:80] 

	#							comment = comment.strip()
								comment = comment.rstrip()

		#						print ( 'Comment from strpos: ' + comment ) 
		#						print ( 'length Correctline from strpos: ' + str( lengthcorrectLine ) ) 

								oldvalue = oldvalue [0:strpos]

								oldvalue = oldvalue.strip()

		#						print ('Old value ' + oldvalue )


							lengthComment = len( comment )
		#					print("lengthComment: "+ str( lengthComment ))


							transtab = maketrans( '"', "'" )
							values1 = values1.translate( transtab )							




							if lengthComment == 0 :

		#						print("No Comment: "+ str( lengthComment ))


								if "'" in values1 or '"' in values1:

									CorrectLine3 = keyword1 + "= " + values1

								else:

									CorrectLine3 = keyword1 + "= " + values1.rjust( 20, " " )

								CorrectLine4 = CorrectLine3.ljust( 80, " " )


							else :

		#						print("Comment > 0: "+ str( lengthComment ))

								if "'" in values1 or '"' in values1:



									CorrectLine2 = keyword1 + "= " + values1.ljust( 20, " " )

									totalLineLength = len( CorrectLine2 ) + lengthComment

									if totalLineLength > 80 and lengthComment > 0 :

										trimLength = 80 - totalLineLength
										comment = comment[ 0 : trimLength ]
										lengthComment = len ( comment ) 

								else:

									CorrectLine2 = keyword1 + "= " + values1.rjust( 20, " " )

								CorrectLine3 = CorrectLine2 + comment

								CorrectLine4 = CorrectLine3.ljust( 80, " " )


							print ('Inserting ' + CorrectLine4 )

							if write == 'yes' :


								FILE3.write ( CorrectLine4 )
						
							m.update ( CorrectLine4 )

#
		FILE2.close()

		if write == 'yes' :

			FILE3.close()


	#	print("readline-1: :" + listfiles)
	#	print("readline-2: :" + listfiles2)


	#print ("filename: "+ oldfitsFile )

	print("fits_bytes: " + str( fits_bytes ) )


	print("MD5: " + m.hexdigest() )
	
	newMD5 = m.hexdigest()
	
	return ( newMD5 )


def renameCorrex ( filename ) :

	cwd = getCWD()
	fitsDir = cwd

	# make filename variable

	oldfitsFile = fitsDir + filename + '.fits'
	newfitsFile = fitsDir + filename + '-A.fits'
	
	if os.path.isfile ( oldfitsFile ) and os.path.isfile ( newfitsFile ) :

		# unlink ".fits" files
	
		os.unlink ( oldfitsFile )

		# rename "-A.fits" file to ".fits" file

		os.rename ( newfitsFile, oldfitsFile )
		
		print ( "Rename successful: " + oldfitsFile )

	else :
		print ( "Not a file: old: " + oldfitsFile + " / new: " + newfitsFile )

# print menu


def checkCRXDir2() :

	cwd = getCWD()
	
	correxDir = '/obsdata6/correx/'
	
#	correxDir = '/stars2/correx/'
#	fitsDir = '/obsdata6/correx/'
	
	#correxDir = '/stars2/html/zcorrex/'
	#fitsDir = '/stars2/html/'
	
	listfilesC = os.listdir ( correxDir )
#	listfilesF = os.listdir ( fitsDir )
	
#	listfilesC2=listfilesC.sort()
	
#	listfilesF=listfilesF.sort()

	dirfiles=[]
		
	for item in listfilesC :
	
		if item is not None and item[-4:] == '.crx' :
		
			dirfiles.append( item )
	
	dirfiles.sort()	
	
	for lineC in dirfiles :

#	correctionsArray = ()
		
#	for lineC in listfilesC2 :
		
		ext = lineC [-4:]
		
		frameID_C = lineC [0:12]
		
#		print ('Frame ID: ' + frameID_C )
		
		if ext == '.crx' :
		
			print ('Corrections File: ' + lineC)
			
	
	return( dirfiles )


while True :

	cwd = getCWD()

	menutext = "\nSubaru Telescope FITS Corrections\n\n"
	menutext += "1. List FrameID's with Corrections\n"
	menutext += "2. Display Actual Corrections\n"
	menutext += "3. Apply Corrections to local FITS\n"
	menutext += "4. Download Corrected FITS\n"
	menutext += "5. Update MD5s\n"
	
	menutext += "6. Exit\n"
	print menutext

	responseCrx = raw_input( "Choose option from above list: " )

	if responseCrx == '1' :

	#	print("Inside Option 1")
		checkCRXDir()

	if responseCrx == '2' :

		displayCorrex ()

	if responseCrx == '3' :


		dirfiles = checkCRXDir ()


		start_time = time.time()

		seq = 0



		for filename in dirfiles :
			seq += 1


	#	filename = 'HSCA90939557'
	#	filename = 'HSCA90939556'
			filename = filename [ 0:12 ]

			CorrectLines = getCorrex( filename )

			print("CorrectLines: " + str( CorrectLines ) )

		#	Corrections = CorrectLines.split( "\n" )

		#	for line in Corrections:

		#		print "check:" + line

			writeCorrex ( filename, CorrectLines )

			renameCorrex ( filename )

		elapsed_time = int(time.time() - start_time)
		print ("Number of corrections : " + str(seq)) 
		print ("Elapsed seconds : " + str(elapsed_time) )
		if elapsed_time > 0 :
		
			print ("Corrections per second: " + str( seq / elapsed_time )  )
	#
	if responseCrx == '4' :

		datafile = '/zadmin/query.dat'
		fullpath = cwd + datafile

		print( 'fullpath: ' + fullpath )

		if os.path.exists(fullpath):

			print( "\n" )	

			print( "1st-Pass Query Data File exists at: "+fullpath+". reading ..." )

			g=open( fullpath, 'r' )

			for line in g:
			
				querydata=line.split()
				qidno=querydata[0]
				qfiles=querydata[1]
				qsize=querydata[2]
				qcompsize=querydata[3]
				quser=querydata[4]
				qpwd=querydata[5]
				qdir=querydata[6]
				qanon=querydata[7]
				qinstr=querydata[8]
				qdate=querydata[9]

				print( "First Pass query.dat" )				
				print( "Query IDNo: " + str( qidno ) )			
				print( "Query Files: " + str( qfiles ) )			
				print( "Query Size: " + BytestoText( qsize ) )					
				print( "Compressed Size: " + BytestoText( qcompsize ) )					
				print( "Download Anonymous: " + qanon )					
				print( "Instrument: " + qinstr )					
				print( "Date: " + qdate )	

			g.close()
					

	if responseCrx == '5' :
	
		dirfiles = checkCRXDir2()
#		dirfiles = [ 'HSCA00020541.crx' ]
		
#		pathname = '/obsdata6/correx/'
		
#		for frame_crx in dirfiles:
			
#			print ('path2: ' + pathname + frame_crx )
		
#			AllCorrectLines = getCorrex ( pathname + frame_crx )
			
#			print AllCorrectLines	


# Calculate md5 for allcorrect lines & print

#			m = hashlib.md5()
#			m.update ( AllCorrectLines )
#			print("MD5: " + m.hexdigest() )


		seq = 0

		crxpathname = '/obsdata6/correx/'
		
		for frame_crx in dirfiles:
					
			AllCorrectLines = getCorrex ( crxpathname + frame_crx )

			print frame_crx
			
			frame_crx = frame_crx[0:12]

			cursor.execute("select filename, idno from frames where frame_id = '%s' " % ( frame_crx ) )	
			row = cursor.fetchone()
			pathname = row[0]
			frameidno = row[1]
##			print ("pathname: "+ pathname )
#			
			if os.path.exists ( pathname ) :
			
				seq += 1
			
#				print ("FoundFile: " + pathname )

				newMD5 = writeCorrex ( pathname, AllCorrectLines )
				
				print( 'results: '+ frame_crx + ' ' + newMD5 )				
#				
				if frameidno > 0 :

					cmd = "update locations set md5result='%s' where frameidno = %s and loc='CORREX' " % ( newMD5, frameidno )
					print ("cmd: " + cmd) 			
					cursor2.execute( cmd ) 	

			print("seq: "+str(seq))
		
	if responseCrx == '6' :

#		exit
		break


